{% extends "plantilla.html"%}
{% block contenido%}
{% load static %}

<div class="intro-section single-cover" id="home-section">

      <div class="slide-1" style="background-image: url('{{ imagen_url }}');" data-stellar-background-ratio="0.5">
        <div class="container">
          <div class="row align-items-center">
            <div class="col-12">
              <div class="row justify-content-center align-items-center text-center">
                <div class="col-lg-6">
                  <h1 data-aos="fade-up" data-aos-delay="0">Carreras</h1>
                  <!-- <div class="col-lg-8 ml-auto" data-aos="fade-up" data-aos-delay="500"> -->
                  <!-- Button trigger modal -->
                  <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#exampleModal">
                    Agregar Carrera
                  </button>
                  <!-- </div> -->
                </div>

              </div>
            </div>

          </div>
        </div>
      </div>
    </div>


    <div class="site-section">
      <div class="container">
        <h2>Listado de Carreras</h2>
        <div class="row">
          <div class="col-md-12">


            <table class="table" id="tbl">
              <thead>
                <tr>
                  <th>ID</th>
                  <th>Nombre</th>
                  <th>Director</th>
                  <th>Logo</th>
                  <th>Duración (años)</th>
                  <th>Creacion </th>
                  <th>Acciones</th>

                </tr>
              </thead>
              <tbody>
                {% for carrera in carreras %}
                  <tr>
                    <td>{{ carrera.idCarreradcp }}</td>
                    <td>{{ carrera.nombreCarreradcp }}</td>
                    <td>{{ carrera.directorCarreradcp }}</td>
                    <td>
                      {% if carrera.logoCarreradcp  %}
                      <a href="{{ carrera.logoCarreradcp.url }}" target="_blank">
                      <img src="{{ carrera.logoCarreradcp.url }}" alt="" height="50px"></a>
                      {% else %}
                      <b>N/A</b>
                      {% endif %}
                    </td>
                    <td>{{ carrera.duracion_aniosCarreradcp }}</td>
                    <td>{{ carrera.fecha_creacionCarreradcp }}</td>
                    <td>
                      <a href="/editarCarrera/{{carrera.idCarreradcp}}" class="btn btn-warning">EDITAR</a>
                      <a href="javascript:void(0)" onclick="eliminarCliente('/eliminarCarrera/{{carrera.idCarreradcp}}');"
                    class="btn btn-danger">
                      Eliminar
                    </a></td>
                  </tr>
                {% endfor %}
              </tbody>
            </table>
            </div>
          </div>
        </div>
      </div>
          <!-- Modal -->
          <div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div class="modal-header bg-secondary">
                  <h3 class="h4 text-black mb-4">Registro de Carrera</h3>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body bg-secondary">
                  <form class="" method="post" action="{% url 'crearCarrera' %}" enctype="multipart/form-data" id="frm_carrera">
                      {% csrf_token %}

                      <div class="mb-3">
                          <label for="nombre" class="form-label">Nombre:</label>
                          <input type="text" class="form-control" id="nombre" name="nombre" required>
                      </div>

                      <div class="mb-3">
                          <label for="director" class="form-label">Director:</label>
                          <input type="text" class="form-control" id="director" name="director" required>
                      </div>

                      <div class="mb-3">
                          <label for="logo" class="form-label">Logo:</label>
                          <input type="file" id="logoInput" name="logo" class="form-control">
                          <script>
                            $(document).ready(function () {
                                $("#logo").fileinput({
                                  //showUpload:false
                                  //showRemove: false,
                                  language:'es',
                                });
                            });
                          </script>

                      </div>


                      <div class="mb-3">
                          <label for="duracion_anios" class="form-label">Duración (años):</label>
                          <input type="number" class="form-control" id="duracion_anios" name="duracion_anios" required>
                      </div>

                      <div class="form-group">
                          <button type="submit" class="btn btn-primary btn-pill">Registrar Carrera</button>
                          <button type="button" class="btn btn-secondary" data-dismiss="modal">Cerrar</button>
                      </div>
                  </form>
                  <script type="text/javascript">
                    $("#frm_carrera").validate({
                      rules: {
                        nombre: {
                          required: true,
                          lettersonly: true // Custom validation rule for letters only
                        },
                        director: {
                          required: true,
                          directorName: true // Custom validation rule for director name
                        },
                        logo: {
                          required: true,
                          extension: "png|jpg|jpeg|gif" // Allowed image file extensions
                        },
                        duracion_anios: {
                          required: true,
                          digits: true,
                          range: [1, 15] // Duracion should be between 1 and 15 years
                        }
                      },
                      messages: {
                        nombre: {
                          required: "Por favor, introduce el nombre",
                          lettersonly: "Por favor, introduce solo letras en el nombre"
                        },
                        director: {
                          required: "Por favor, introduce el nombre del director",
                          directorName: "Por favor, introduce al menos un nombre y un apellido para el director"
                        },
                        logo: {
                          required: "Por favor, selecciona un archivo de imagen",
                          extension: "Por favor, selecciona un archivo de imagen con una extensión válida (png, jpg, jpeg, gif)"
                        },
                        duracion_anios: {
                          required: "Por favor, introduce la duración en años",
                          digits: "Por favor, introduce solo números enteros",
                          range: "Por favor, introduce un valor entre 1 y 15"
                        }
                      },
                      submitHandler: function(form) {
                        form.submit();
                      },
                      highlight: function (element, errorClass, validClass) {
                        // Añade clases de Bootstrap para resaltar errores
                        $(element).addClass("is-invalid").removeClass("is-valid");
                      },
                      unhighlight: function (element, errorClass, validClass) {
                        // Añade clases de Bootstrap cuando no hay errores
                        $(element).removeClass("is-invalid").addClass("is-valid");
                      },
                    });

                    // Custom validation rule for letters only
                    $.validator.addMethod("lettersonly", function(value, element) {
                      return /^[a-zA-ZáéíóúüñÁÉÍÓÚÜÑ\s]+$/.test(value);
                    }, "Por favor, introduce solo letras");

                    // Custom validation rule for director name
                    $.validator.addMethod("directorName", function(value, element) {
                      return /^[a-zA-ZáéíóúüñÁÉÍÓÚÜÑ]+\s[a-zA-ZáéíóúüñÁÉÍÓÚÜÑ]+$/.test(value);
                    }, "Por favor, introduce al menos un nombre y un apellido para el director");

                  </script>
                </div>
                <div class="modal-footer bg-secondary">
                </div>
              </div>
            </div>
          </div>
          <script type="text/javascript">
                   //let table = new DataTable('#tbl_clientes');
                    $('#tbl').DataTable( {
                      dom: 'Bfrtip',
                      buttons: [
                          {
                              extend: 'pdfHtml5',
                              messageTop: 'PDF created by PDFMake with Buttons for DataTables.'
                          },
                          'print',
                          'csv'
                      ]
                    } );
                  </script>



{% endblock %}
